/*
  Tabela FILIAL: Cadastro de Filial*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela de FILIAL*/
/* Objetivo: Gerar log de alteraes realizadas na tabela de Filial, utilizando a tabela geral de Logs*/
/* de Operaes
*/

IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_SUP_FILIAL'  AND
                TYPE   = 'TR'              AND
                U.UID  = O.UID             AND
                U.NAME = USER)
DROP TRIGGER LOG_SUP_FILIAL
GO

CREATE TRIGGER LOG_SUP_FILIAL
ON FILIAL
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_TIPO                VARCHAR(1);
   DECLARE @V_DSREMOTEADDR        VARCHAR(15);
   DECLARE @V_DSREMOTEHOST        VARCHAR(15);
   DECLARE @V_DSSERVERRDM         VARCHAR(20);
   DECLARE @V_DSSERVMETHOD        VARCHAR(30);
   DECLARE @V_DSREMOTEOPER        VARCHAR(12);
   DECLARE @V_DESC                VARCHAR(500);
   DECLARE @V_CDFILLOGOPER        VARCHAR(4);
   DECLARE @V_ITPESQ              VARCHAR(40);
   DECLARE @V_NMOPERADOR          VARCHAR(40);

   /*VARIAVEIS DO C_CURSOR*/
   DECLARE @V_IDCOMANDO           VARCHAR(1);
   DECLARE @V_NEW_CDFILIAL        VARCHAR(4);
   DECLARE @V_NEW_CDREGIAO        VARCHAR(3);
   DECLARE @V_NEW_NMFILIAL        VARCHAR(30);
   DECLARE @V_NEW_CDCONTCTBL      VARCHAR(20);
   DECLARE @V_NEW_CDGRUPOFISC     VARCHAR(3);
   DECLARE @V_NEW_CDSEGMER        VARCHAR(5);
   DECLARE @V_NEW_NRINSJURFILI    VARCHAR(20);
   DECLARE @V_NEW_CDFILIFISC      VARCHAR(4);
   DECLARE @V_NEW_CDEMPRESA       VARCHAR(2);
   DECLARE @V_NEW_CDINSCMUNI      VARCHAR(16);
   DECLARE @V_NEW_CDINSCESTA      VARCHAR(16);
   DECLARE @V_NEW_IDCNTRRESC      VARCHAR(1);
   DECLARE @V_NEW_NMRAZSOCFILI    VARCHAR(40);
   DECLARE @V_NEW_CDTPCONTRATO    VARCHAR(2);
   DECLARE @V_NEW_CDSERIE         VARCHAR(5);
   DECLARE @V_NEW_CDCENTCUST      VARCHAR(4);
   DECLARE @V_NEW_IDUTFILIPADR    VARCHAR(1);
   DECLARE @V_NEW_DTINCONTRFIL    DATE;
   DECLARE @V_NEW_DTFICONTRFIL    DATE;
   DECLARE @V_NEW_CDFORNOPELOG    VARCHAR(21);
   DECLARE @V_NEW_IDCOMPARQXMLFIL VARCHAR(1);
   DECLARE @V_NEW_NRINSCSUFRAMAFI VARCHAR(9);
   DECLARE @V_NEW_IDENDEMISFIL    VARCHAR(1);
   DECLARE @V_NEW_IDENDCFOPFIL    VARCHAR(1);
   DECLARE @V_NEW_CDFORNAGETERC   VARCHAR(21);

   DECLARE @V_OLD_CDFILIAL        VARCHAR(4);
   DECLARE @V_OLD_CDREGIAO        VARCHAR(3);
   DECLARE @V_OLD_NMFILIAL        VARCHAR(30);
   DECLARE @V_OLD_CDCONTCTBL      VARCHAR(20);
   DECLARE @V_OLD_CDGRUPOFISC     VARCHAR(3);
   DECLARE @V_OLD_CDSEGMER        VARCHAR(5);
   DECLARE @V_OLD_NRINSJURFILI    VARCHAR(20);
   DECLARE @V_OLD_CDFILIFISC      VARCHAR(4);
   DECLARE @V_OLD_CDEMPRESA       VARCHAR(2);
   DECLARE @V_OLD_CDINSCMUNI      VARCHAR(16);
   DECLARE @V_OLD_CDINSCESTA      VARCHAR(16);
   DECLARE @V_OLD_IDCNTRRESC      VARCHAR(1);
   DECLARE @V_OLD_NMRAZSOCFILI    VARCHAR(40);
   DECLARE @V_OLD_CDTPCONTRATO    VARCHAR(2);
   DECLARE @V_OLD_CDSERIE         VARCHAR(5);
   DECLARE @V_OLD_CDCENTCUST      VARCHAR(4);
   DECLARE @V_OLD_IDUTFILIPADR    VARCHAR(1);
   DECLARE @V_OLD_DTINCONTRFIL    DATE;
   DECLARE @V_OLD_DTFICONTRFIL    DATE;
   DECLARE @V_OLD_CDFORNOPELOG    VARCHAR(21);
   DECLARE @V_OLD_IDCOMPARQXMLFIL VARCHAR(1);
   DECLARE @V_OLD_NRINSCSUFRAMAFI VARCHAR(9);
   DECLARE @V_OLD_IDENDEMISFIL    VARCHAR(1);
   DECLARE @V_OLD_IDENDCFOPFIL    VARCHAR(1);
   DECLARE @V_OLD_CDFORNAGETERC   VARCHAR(21);

BEGIN
   /* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   SET @V_TIPO         = '0';
   SET @V_DESC         = '';
   SET @V_ITPESQ       = '';
   SET @V_NMOPERADOR   = '';
   SET @V_CDFILLOGOPER = '';

   EXEC NMUSUARIO  @V_NMOPERADOR;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;

   DECLARE C_CURSOR CURSOR FOR
      SELECT 'D' IDCOMANDO,
             CDFILIAL,
             CDREGIAO,
             NMFILIAL,
             CDCONTCTBL,
             CDGRUPOFISC,
             CDSEGMER,
             NRINSJURFILI,
             CDFILIFISC,
             CDEMPRESA,
             CDINSCMUNI,
             CDINSCESTA,
             IDCNTRRESC,
             NMRAZSOCFILI,
             CDTPCONTRATO,
             CDSERIE,
             CDCENTCUST,
             IDUTFILIPADR,
             DTINCONTRFIL,
             DTFICONTRFIL,
             CDFORNOPELOG,
             IDCOMPARQXMLFIL,
             NRINSCSUFRAMAFI,
             IDENDEMISFIL,
             IDENDCFOPFIL,
             CDFORNAGETERC,

             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL
      FROM
         DELETED
      WHERE
         CDFILIAL NOT IN (SELECT CDFILIAL FROM INSERTED)
      UNION ALL

      SELECT 'U' IDCOMANDO,
             DELETED.CDFILIAL,
             DELETED.CDREGIAO,
             DELETED.NMFILIAL,
             DELETED.CDCONTCTBL,
             DELETED.CDGRUPOFISC,
             DELETED.CDSEGMER,
             DELETED.NRINSJURFILI,
             DELETED.CDFILIFISC,
             DELETED.CDEMPRESA,
             DELETED.CDINSCMUNI,
             DELETED.CDINSCESTA,
             DELETED.IDCNTRRESC,
             DELETED.NMRAZSOCFILI,
             DELETED.CDTPCONTRATO,
             DELETED.CDSERIE,
             DELETED.CDCENTCUST,
             DELETED.IDUTFILIPADR,
             DELETED.DTINCONTRFIL,
             DELETED.DTFICONTRFIL,
             DELETED.CDFORNOPELOG,
             DELETED.IDCOMPARQXMLFIL,
             DELETED.NRINSCSUFRAMAFI,
             DELETED.IDENDEMISFIL,
             DELETED.IDENDCFOPFIL,
             DELETED.CDFORNAGETERC,

             INSERTED.CDFILIAL,
             INSERTED.CDREGIAO,
             INSERTED.NMFILIAL,
             INSERTED.CDCONTCTBL,
             INSERTED.CDGRUPOFISC,
             INSERTED.CDSEGMER,
             INSERTED.NRINSJURFILI,
             INSERTED.CDFILIFISC,
             INSERTED.CDEMPRESA,
             INSERTED.CDINSCMUNI,
             INSERTED.CDINSCESTA,
             INSERTED.IDCNTRRESC,
             INSERTED.NMRAZSOCFILI,
             INSERTED.CDTPCONTRATO,
             INSERTED.CDSERIE,
             INSERTED.CDCENTCUST,
             INSERTED.IDUTFILIPADR,
             INSERTED.DTINCONTRFIL,
             INSERTED.DTFICONTRFIL,
             INSERTED.CDFORNOPELOG,
             INSERTED.IDCOMPARQXMLFIL,
             INSERTED.NRINSCSUFRAMAFI,
             INSERTED.IDENDEMISFIL,
             INSERTED.IDENDCFOPFIL,
             INSERTED.CDFORNAGETERC
      FROM
         INSERTED, DELETED
      WHERE
         INSERTED.CDFILIAL = DELETED.CDFILIAL
      UNION ALL

      SELECT 'I' IDCOMANDO,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,

             CDFILIAL,
             CDREGIAO,
             NMFILIAL,
             CDCONTCTBL,
             CDGRUPOFISC,
             CDSEGMER,
             NRINSJURFILI,
             CDFILIFISC,
             CDEMPRESA,
             CDINSCMUNI,
             CDINSCESTA,
             IDCNTRRESC,
             NMRAZSOCFILI,
             CDTPCONTRATO,
             CDSERIE,
             CDCENTCUST,
             IDUTFILIPADR,
             DTINCONTRFIL,
             DTFICONTRFIL,
             CDFORNOPELOG,
             IDCOMPARQXMLFIL,
             NRINSCSUFRAMAFI,
             IDENDEMISFIL,
             IDENDCFOPFIL,
             CDFORNAGETERC
      FROM INSERTED
      WHERE CDFILIAL NOT IN (SELECT CDFILIAL FROM DELETED);

      OPEN C_CURSOR;
      FETCH NEXT FROM C_CURSOR INTO @V_IDCOMANDO,
                                    @V_OLD_CDFILIAL,        @V_OLD_CDREGIAO,        @V_OLD_NMFILIAL,     @V_OLD_CDCONTCTBL,
	   		                        @V_OLD_CDGRUPOFISC,     @V_OLD_CDSEGMER,        @V_OLD_NRINSJURFILI, @V_OLD_CDFILIFISC,
		   	                        @V_OLD_CDEMPRESA,       @V_OLD_CDINSCMUNI,      @V_OLD_CDINSCESTA,   @V_OLD_IDCNTRRESC,
			                           @V_OLD_NMRAZSOCFILI,    @V_OLD_CDTPCONTRATO,    @V_OLD_CDSERIE,      @V_OLD_CDCENTCUST,
                                    @V_OLD_IDUTFILIPADR,    @V_OLD_DTINCONTRFIL,    @V_OLD_DTFICONTRFIL, @V_OLD_CDFORNOPELOG,
                                    @V_OLD_IDCOMPARQXMLFIL, @V_OLD_NRINSCSUFRAMAFI, @V_OLD_IDENDEMISFIL, @V_OLD_IDENDCFOPFIL, @V_OLD_CDFORNAGETERC,

                                    @V_NEW_CDFILIAL,        @V_NEW_CDREGIAO,        @V_NEW_NMFILIAL,     @V_NEW_CDCONTCTBL,
                                    @V_NEW_CDGRUPOFISC,     @V_NEW_CDSEGMER,        @V_NEW_NRINSJURFILI, @V_NEW_CDFILIFISC,
                                    @V_NEW_CDEMPRESA,       @V_NEW_CDINSCMUNI,      @V_NEW_CDINSCESTA,   @V_NEW_IDCNTRRESC,
                                    @V_NEW_NMRAZSOCFILI,    @V_NEW_CDTPCONTRATO,    @V_NEW_CDSERIE,      @V_NEW_CDCENTCUST,
                                    @V_NEW_IDUTFILIPADR,    @V_NEW_DTINCONTRFIL,    @V_NEW_DTFICONTRFIL, @V_NEW_CDFORNOPELOG,
                                    @V_NEW_IDCOMPARQXMLFIL, @V_NEW_NRINSCSUFRAMAFI, @V_NEW_IDENDEMISFIL, @V_NEW_IDENDCFOPFIL, @V_NEW_CDFORNAGETERC;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         IF @V_IDCOMANDO = 'D' BEGIN /*DELETING*/
            IF @V_OLD_CDFILIAL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' CodFilial=' + @V_OLD_CDFILIAL;
            END;

            IF @V_OLD_CDREGIAO IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Regiao=' + @V_OLD_CDREGIAO;
            END;

            IF @V_OLD_NMFILIAL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Filial=' + @V_OLD_NMFILIAL;
            END;

            IF @V_OLD_CDCONTCTBL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' ContaContabil=' + @V_OLD_CDCONTCTBL;
            END;

            IF @V_OLD_CDGRUPOFISC IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' GrupoFiscal=' + @V_OLD_CDGRUPOFISC;
            END;

            IF @V_OLD_CDSEGMER IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' SegMercado=' + @V_OLD_CDSEGMER;
            END;

            IF @V_OLD_NRINSJURFILI IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' InscrJur=' + @V_OLD_NRINSJURFILI;
            END;

            IF @V_OLD_CDFILIFISC IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' FilialFisc=' + @V_OLD_CDFILIFISC;
            END;

            IF @V_OLD_CDEMPRESA IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Empresa=' + @V_OLD_CDEMPRESA;
            END;

            IF @V_OLD_CDINSCMUNI IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' InscrMunic=' + @V_OLD_CDINSCMUNI;
            END;

            IF @V_OLD_CDINSCESTA IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' InscrEsta=' + @V_OLD_CDINSCESTA;
            END;

            IF @V_OLD_IDCNTRRESC IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' ContratoRescindido=' + @V_OLD_IDCNTRRESC;
            END;

            IF @V_OLD_NMRAZSOCFILI IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' RazaoSoc=' + @V_OLD_NMRAZSOCFILI;
            END;

            IF @V_OLD_CDTPCONTRATO IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' TipoContrato=' + @V_OLD_CDTPCONTRATO;
            END;

            IF @V_OLD_CDSERIE IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Serie=' + @V_OLD_CDSERIE;
            END;

            IF @V_OLD_CDCENTCUST IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' CentroCusto=' + @V_OLD_CDCENTCUST;
            END;

            IF @V_OLD_IDUTFILIPADR IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' FilialPadrao=' + @V_OLD_IDUTFILIPADR;
            END;

            IF @V_OLD_DTINCONTRFIL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DataIni=' + CONVERT(VARCHAR,@V_OLD_DTINCONTRFIL,103);
            END;

            IF @V_OLD_DTFICONTRFIL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DataFim=' + CONVERT(VARCHAR,@V_OLD_DTFICONTRFIL,103);
            END;

            IF @V_OLD_CDFORNOPELOG IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' ForneLogis=' + @V_OLD_CDFORNOPELOG;
            END;

            IF @V_OLD_IDCOMPARQXMLFIL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' CompactaXML=' + @V_OLD_IDCOMPARQXMLFIL;
            END;

            IF @V_OLD_NRINSCSUFRAMAFI IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' InscSuframa=' + @V_OLD_NRINSCSUFRAMAFI;
            END;

            IF @V_OLD_IDENDEMISFIL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' IdEndEmissao=' + @V_OLD_IDENDEMISFIL;
            END;

            IF @V_OLD_IDENDCFOPFIL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' IdEndCFOP=' + @V_OLD_IDENDCFOPFIL;
            END;

            IF @V_OLD_CDFORNAGETERC IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' IdAgentTerc=' + @V_OLD_CDFORNAGETERC;
            END;

            SET @V_TIPO         = '3';
            SET @V_ITPESQ       = @V_OLD_CDFILIAL;
            SET @V_CDFILLOGOPER = @V_OLD_CDFILIAL;
         END
         ELSE IF @V_IDCOMANDO = 'U' BEGIN /*UPDATING*/
            IF (ISNULL(@V_NEW_CDFILIAL,'!')           <> ISNULL(@V_OLD_CDFILIAL,'!'))           OR
               (ISNULL(@V_NEW_CDREGIAO,'!')           <> ISNULL(@V_OLD_CDREGIAO,'!'))           OR
               (ISNULL(@V_NEW_NMFILIAL,'!')           <> ISNULL(@V_OLD_NMFILIAL,'!'))           OR
               (ISNULL(@V_NEW_CDCONTCTBL,'!')         <> ISNULL(@V_OLD_CDCONTCTBL,'!'))         OR
               (ISNULL(@V_NEW_CDGRUPOFISC,'!')        <> ISNULL(@V_OLD_CDGRUPOFISC,'!'))        OR
               (ISNULL(@V_NEW_CDSEGMER,'!')           <> ISNULL(@V_OLD_CDSEGMER,'!'))           OR
               (ISNULL(@V_NEW_NRINSJURFILI,'!')       <> ISNULL(@V_OLD_NRINSJURFILI,'!'))       OR
               (ISNULL(@V_NEW_CDFILIFISC,'!')         <> ISNULL(@V_OLD_CDFILIFISC,'!'))         OR
               (ISNULL(@V_NEW_CDEMPRESA,'!')          <> ISNULL(@V_OLD_CDEMPRESA,'!'))          OR
               (ISNULL(@V_NEW_CDINSCMUNI,'!')         <> ISNULL(@V_OLD_CDINSCMUNI,'!'))         OR
               (ISNULL(@V_NEW_CDINSCESTA,'!')         <> ISNULL(@V_OLD_CDINSCESTA,'!'))         OR
               (ISNULL(@V_NEW_IDCNTRRESC,'!')         <> ISNULL(@V_OLD_IDCNTRRESC,'!'))         OR
               (ISNULL(@V_NEW_NMRAZSOCFILI,'!')       <> ISNULL(@V_OLD_NMRAZSOCFILI,'!'))       OR
               (ISNULL(@V_NEW_CDTPCONTRATO,'!')       <> ISNULL(@V_OLD_CDTPCONTRATO,'!'))       OR
               (ISNULL(@V_NEW_CDSERIE,'!')            <> ISNULL(@V_OLD_CDSERIE,'!'))            OR
               (ISNULL(@V_NEW_CDCENTCUST,'!')         <> ISNULL(@V_OLD_CDCENTCUST,'!'))         OR
               (ISNULL(@V_NEW_IDUTFILIPADR,'!')       <> ISNULL(@V_OLD_IDUTFILIPADR,'!'))       OR
               (ISNULL(@V_NEW_DTINCONTRFIL,GETDATE()) <> ISNULL(@V_OLD_DTINCONTRFIL,GETDATE())) OR
               (ISNULL(@V_NEW_DTFICONTRFIL,GETDATE()) <> ISNULL(@V_OLD_DTFICONTRFIL,GETDATE())) OR
               (ISNULL(@V_NEW_CDFORNOPELOG,'!')       <> ISNULL(@V_OLD_CDFORNOPELOG,'!'))       OR
               (ISNULL(@V_NEW_IDCOMPARQXMLFIL,'!')    <> ISNULL(@V_OLD_IDCOMPARQXMLFIL,'!'))    OR
               (ISNULL(@V_NEW_NRINSCSUFRAMAFI,'!')    <> ISNULL(@V_OLD_NRINSCSUFRAMAFI,'!'))    OR
               (ISNULL(@V_NEW_IDENDEMISFIL,'!')       <> ISNULL(@V_OLD_IDENDEMISFIL,'!'))       OR
               (ISNULL(@V_NEW_CDFORNAGETERC,'!')      <> ISNULL(@V_OLD_CDFORNAGETERC,'!'))      OR
               (ISNULL(@V_NEW_IDENDCFOPFIL,'!')       <> ISNULL(@V_OLD_IDENDCFOPFIL,'!'))       BEGIN

               IF (ISNULL(@V_NEW_CDFILIAL,'!') <> ISNULL(@V_OLD_CDFILIAL,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' CodFilial=' + @V_NEW_CDFILIAL;
               END;

               IF (ISNULL(@V_NEW_CDREGIAO,'!') <> ISNULL(@V_OLD_CDREGIAO,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Regiao=' + @V_NEW_CDREGIAO;
               END;

               IF (ISNULL(@V_NEW_NMFILIAL,'!') <> ISNULL(@V_OLD_NMFILIAL,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Filial=' + @V_NEW_NMFILIAL;
               END;

               IF (ISNULL(@V_NEW_CDCONTCTBL,'!') <> ISNULL(@V_OLD_CDCONTCTBL,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' ContaContabil=' + @V_NEW_CDCONTCTBL;
               END;

               IF (ISNULL(@V_NEW_CDGRUPOFISC,'!') <> ISNULL(@V_OLD_CDGRUPOFISC,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' GrupoFiscal=' + @V_NEW_CDGRUPOFISC;
               END;

               IF (ISNULL(@V_NEW_CDSEGMER,'!') <> ISNULL(@V_OLD_CDSEGMER,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' SegMercado=' + @V_NEW_CDSEGMER;
               END;

               IF (ISNULL(@V_NEW_NRINSJURFILI,'!') <> ISNULL(@V_OLD_NRINSJURFILI,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' InscrJur=' + @V_NEW_NRINSJURFILI;
               END;

               IF (ISNULL(@V_NEW_CDFILIFISC,'!') <> ISNULL(@V_OLD_CDFILIFISC,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' FilialFisc=' + @V_NEW_CDFILIFISC;
               END;

               IF (ISNULL(@V_NEW_CDEMPRESA,'!') <> ISNULL(@V_OLD_CDEMPRESA,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Empresa=' + @V_NEW_CDEMPRESA;
               END;

               IF (ISNULL(@V_NEW_CDINSCMUNI,'!') <> ISNULL(@V_OLD_CDINSCMUNI,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' InscrMunic=' + @V_NEW_CDINSCMUNI;
               END;

               IF (ISNULL(@V_NEW_CDINSCESTA,'!') <> ISNULL(@V_OLD_CDINSCESTA,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' InscrEsta=' + @V_NEW_CDINSCESTA;
               END;

               IF (ISNULL(@V_NEW_IDCNTRRESC,'!') <> ISNULL(@V_OLD_IDCNTRRESC,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' ContratoRescindido=' + @V_NEW_IDCNTRRESC;
               END;

               IF (ISNULL(@V_NEW_NMRAZSOCFILI,'!') <> ISNULL(@V_OLD_NMRAZSOCFILI,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' RazaoSoc=' + @V_NEW_NMRAZSOCFILI;
               END;

               IF (ISNULL(@V_NEW_CDTPCONTRATO,'!') <> ISNULL(@V_OLD_CDTPCONTRATO,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' TipoContrato=' + @V_NEW_CDTPCONTRATO;
               END;

               IF (ISNULL(@V_NEW_CDSERIE,'!') <> ISNULL(@V_OLD_CDSERIE,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Serie=' + @V_NEW_CDSERIE;
               END;

               IF (ISNULL(@V_NEW_CDCENTCUST,'!') <> ISNULL(@V_OLD_CDCENTCUST,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' CentroCusto=' + @V_NEW_CDCENTCUST;
               END;

               IF (ISNULL(@V_NEW_IDUTFILIPADR,'!') <> ISNULL(@V_OLD_IDUTFILIPADR,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' FilialPadrao=' + @V_NEW_IDUTFILIPADR;
               END;

               IF (ISNULL(@V_NEW_DTINCONTRFIL,GETDATE()) <> ISNULL(@V_OLD_DTINCONTRFIL,GETDATE())) BEGIN
                  SET @V_DESC = @V_DESC + ' DataIni=' + CONVERT(VARCHAR,@V_NEW_DTINCONTRFIL,103);
               END;

               IF (ISNULL(@V_NEW_DTFICONTRFIL,GETDATE()) <> ISNULL(@V_OLD_DTFICONTRFIL,GETDATE())) BEGIN
                  SET @V_DESC = @V_DESC + ' DataFim=' + CONVERT(VARCHAR,@V_NEW_DTFICONTRFIL,103);
               END;

               IF (ISNULL(@V_NEW_CDFORNOPELOG,'!') <> ISNULL(@V_OLD_CDFORNOPELOG,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' ForneLogis=' + @V_NEW_CDFORNOPELOG;
               END;

               IF (ISNULL(@V_NEW_IDCOMPARQXMLFIL,'!') <> ISNULL(@V_OLD_IDCOMPARQXMLFIL,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' CompactaXML=' + @V_NEW_IDCOMPARQXMLFIL;
               END;

               IF (ISNULL(@V_NEW_NRINSCSUFRAMAFI,'!') <> ISNULL(@V_OLD_NRINSCSUFRAMAFI,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' InscSuframa=' + @V_NEW_NRINSCSUFRAMAFI;
               END;

               IF (ISNULL(@V_NEW_IDENDEMISFIL,'!') <> ISNULL(@V_OLD_IDENDEMISFIL,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' IdEndEmissao=' + @V_NEW_IDENDEMISFIL;
               END;

               IF (ISNULL(@V_NEW_IDENDCFOPFIL,'!') <> ISNULL(@V_OLD_IDENDCFOPFIL,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' IdEndCFOP=' + @V_NEW_IDENDCFOPFIL;
               END;

               IF (ISNULL(@V_NEW_CDFORNAGETERC,'!') <> ISNULL(@V_OLD_CDFORNAGETERC,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' IdAgentTerc=' + @V_NEW_CDFORNAGETERC;
               END;

               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_CDFILIAL;
               SET @V_CDFILLOGOPER = @V_OLD_CDFILIAL;
            END;
         END
         ELSE BEGIN /*INSERT*/
            IF (ISNULL(@V_NEW_CDFILIAL,'!') <> ISNULL(@V_OLD_CDFILIAL,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' CodFilial=' + @V_NEW_CDFILIAL;
            END;

            IF (ISNULL(@V_NEW_CDREGIAO,'!') <> ISNULL(@V_OLD_CDREGIAO,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' Regiao=' + @V_NEW_CDREGIAO;
            END;

            IF (ISNULL(@V_NEW_NMFILIAL,'!') <> ISNULL(@V_OLD_NMFILIAL,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' Filial=' + @V_NEW_NMFILIAL;
            END;

            IF (ISNULL(@V_NEW_CDCONTCTBL,'!') <> ISNULL(@V_OLD_CDCONTCTBL,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' ContaContabil=' + @V_NEW_CDCONTCTBL;
            END;

            IF (ISNULL(@V_NEW_CDGRUPOFISC,'!') <> ISNULL(@V_OLD_CDGRUPOFISC,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' GrupoFiscal=' + @V_NEW_CDGRUPOFISC;
            END;

            IF (ISNULL(@V_NEW_CDSEGMER,'!') <> ISNULL(@V_OLD_CDSEGMER,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' SegMercado=' + @V_NEW_CDSEGMER;
            END;

            IF (ISNULL(@V_NEW_NRINSJURFILI,'!') <> ISNULL(@V_OLD_NRINSJURFILI,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' InscrJur=' + @V_NEW_NRINSJURFILI;
            END;

            IF (ISNULL(@V_NEW_CDFILIFISC,'!') <> ISNULL(@V_OLD_CDFILIFISC,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' FilialFisc=' + @V_NEW_CDFILIFISC;
            END;

            IF (ISNULL(@V_NEW_CDEMPRESA,'!') <> ISNULL(@V_OLD_CDEMPRESA,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' Empresa=' + @V_NEW_CDEMPRESA;
            END;

            IF (ISNULL(@V_NEW_CDINSCMUNI,'!') <> ISNULL(@V_OLD_CDINSCMUNI,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' InscrMunic=' + @V_NEW_CDINSCMUNI;
            END;

            IF (ISNULL(@V_NEW_CDINSCESTA,'!') <> ISNULL(@V_OLD_CDINSCESTA,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' InscrEsta=' + @V_NEW_CDINSCESTA;
            END;

            IF (ISNULL(@V_NEW_IDCNTRRESC,'!') <> ISNULL(@V_OLD_IDCNTRRESC,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' ContratoRescindido=' + @V_NEW_IDCNTRRESC;
            END;

            IF (ISNULL(@V_NEW_NMRAZSOCFILI,'!') <> ISNULL(@V_OLD_NMRAZSOCFILI,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' RazaoSoc=' + @V_NEW_NMRAZSOCFILI;
            END;

            IF (ISNULL(@V_NEW_CDTPCONTRATO,'!') <> ISNULL(@V_OLD_CDTPCONTRATO,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' TipoContrato=' + @V_NEW_CDTPCONTRATO;
            END;

            IF (ISNULL(@V_NEW_CDSERIE,'!') <> ISNULL(@V_OLD_CDSERIE,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' Serie=' + @V_NEW_CDSERIE;
            END;

            IF (ISNULL(@V_NEW_CDCENTCUST,'!') <> ISNULL(@V_OLD_CDCENTCUST,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' CentroCusto=' + @V_NEW_CDCENTCUST;
            END;

            IF (ISNULL(@V_NEW_IDUTFILIPADR,'!') <> ISNULL(@V_OLD_IDUTFILIPADR,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' FilialPadrao=' + @V_NEW_IDUTFILIPADR;
            END;

            IF (ISNULL(@V_NEW_DTINCONTRFIL,GETDATE()) <> ISNULL(@V_OLD_DTINCONTRFIL,GETDATE())) BEGIN
               SET @V_DESC = @V_DESC + ' DataIni=' + CONVERT(VARCHAR,@V_NEW_DTINCONTRFIL,103);
            END;

            IF (ISNULL(@V_NEW_DTFICONTRFIL,GETDATE()) <> ISNULL(@V_OLD_DTFICONTRFIL,GETDATE())) BEGIN
               SET @V_DESC = @V_DESC + ' DataFim=' + CONVERT(VARCHAR,@V_NEW_DTFICONTRFIL,103);
            END;

            IF (ISNULL(@V_NEW_CDFORNOPELOG,'!') <> ISNULL(@V_OLD_CDFORNOPELOG,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' ForneLogis=' + @V_NEW_CDFORNOPELOG;
            END;

            IF (ISNULL(@V_NEW_IDCOMPARQXMLFIL,'!') <> ISNULL(@V_OLD_IDCOMPARQXMLFIL,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' CompactaXML=' + @V_NEW_IDCOMPARQXMLFIL;
            END;

            IF (ISNULL(@V_NEW_NRINSCSUFRAMAFI,'!') <> ISNULL(@V_OLD_NRINSCSUFRAMAFI,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' InscSuframa=' + @V_NEW_NRINSCSUFRAMAFI;
            END;

            IF (ISNULL(@V_NEW_IDENDEMISFIL,'!') <> ISNULL(@V_OLD_IDENDEMISFIL,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' IdEndEmissao=' + @V_NEW_IDENDEMISFIL;
            END;

            IF (ISNULL(@V_NEW_IDENDCFOPFIL,'!') <> ISNULL(@V_OLD_IDENDCFOPFIL,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' IdEndCFOP=' + @V_NEW_IDENDCFOPFIL;
            END;

            IF (ISNULL(@V_NEW_CDFORNAGETERC,'!') <> ISNULL(@V_OLD_CDFORNAGETERC,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' IdAgentTerc=' + @V_NEW_CDFORNAGETERC;
            END;

            SET @V_TIPO         = '1';
            SET @V_ITPESQ       = @V_NEW_CDFILIAL;
            SET @V_CDFILLOGOPER = @V_NEW_CDFILIAL;
         END;

         IF @V_TIPO <> '0' BEGIN
            IF NOT @V_DESC IS NULL BEGIN
               SET @V_DESC   = SUBSTRING(@V_DESC, 1, 300);
               INSERT INTO LOGOPERA
                  (NMTABELA,     DTOPERACAO,   NMRESPOPER,  IDTIPOOPER,   DSOPERACAO,  CDPESQITEM,
                   DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
               VALUES
                  ('FILIAL', GETDATE(), ISNULL(@V_NMOPERADOR,' '), @V_TIPO, @V_DESC, @V_ITPESQ, @V_DSSERVERRDM,
                   @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_DSREMOTEOPER, @V_CDFILLOGOPER);
            END;
         END;

         FETCH NEXT FROM C_CURSOR INTO @V_IDCOMANDO,
                                       @V_OLD_CDFILIAL,        @V_OLD_CDREGIAO,        @V_OLD_NMFILIAL,     @V_OLD_CDCONTCTBL,
	      		                        @V_OLD_CDGRUPOFISC,     @V_OLD_CDSEGMER,        @V_OLD_NRINSJURFILI, @V_OLD_CDFILIFISC,
		      	                        @V_OLD_CDEMPRESA,       @V_OLD_CDINSCMUNI,      @V_OLD_CDINSCESTA,   @V_OLD_IDCNTRRESC,
			                              @V_OLD_NMRAZSOCFILI,    @V_OLD_CDTPCONTRATO,    @V_OLD_CDSERIE,      @V_OLD_CDCENTCUST,
                                       @V_OLD_IDUTFILIPADR,    @V_OLD_DTINCONTRFIL,    @V_OLD_DTFICONTRFIL, @V_OLD_CDFORNOPELOG,
                                       @V_OLD_IDCOMPARQXMLFIL, @V_OLD_NRINSCSUFRAMAFI, @V_OLD_IDENDEMISFIL, @V_OLD_IDENDCFOPFIL, @V_OLD_CDFORNAGETERC,

                                       @V_NEW_CDFILIAL,        @V_NEW_CDREGIAO,        @V_NEW_NMFILIAL,     @V_NEW_CDCONTCTBL,
                                       @V_NEW_CDGRUPOFISC,     @V_NEW_CDSEGMER,        @V_NEW_NRINSJURFILI, @V_NEW_CDFILIFISC,
                                       @V_NEW_CDEMPRESA,       @V_NEW_CDINSCMUNI,      @V_NEW_CDINSCESTA,   @V_NEW_IDCNTRRESC,
                                       @V_NEW_NMRAZSOCFILI,    @V_NEW_CDTPCONTRATO,    @V_NEW_CDSERIE,      @V_NEW_CDCENTCUST,
                                       @V_NEW_IDUTFILIPADR,    @V_NEW_DTINCONTRFIL,    @V_NEW_DTFICONTRFIL, @V_NEW_CDFORNOPELOG,
                                       @V_NEW_IDCOMPARQXMLFIL, @V_NEW_NRINSCSUFRAMAFI, @V_NEW_IDENDEMISFIL, @V_NEW_IDENDCFOPFIL, @V_NEW_CDFORNAGETERC;
   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_SUP_FILIAL','6.05.xxx';
GO

